import java.util.*;

public class MoneyExpressionEvaluatorClass extends Object {
    private static int GetOperatorPrecedence(char operator) throws Exception {
        if (operator == '+' || operator == '-') {
            return 1;
        } else if (operator == '*' || operator == '/') {
            return 2;
        } else {
            throw (new Exception("Invalid operator"));
        }
    }

    private static long EvaluateOperator(char operator, long val1, long val2) throws Exception {
        if (operator == '+') {
            return val1 + val2;
        } else if (operator == '-') {
            return val1 - val2;
        } else if (operator == '*') {
            return (val1 * val2) / 100;
        } else if (operator == '/') {
            return (val1 * 100) / val2;
        } else {
            throw (new Exception("Invalid operator"));
        }
    }

    public static long Evaluate(String expression) throws Exception {
        char   current_operator = 0;
        long   current_value;
        String current_str_value = "";
        Stack  val_stack, op_stack;

        val_stack = new Stack();
        op_stack  = new Stack();

        for (int i = 0; i < expression.length(); i++) {
            if (Character.isDigit(expression.charAt(i)) ||
                expression.charAt(i) == '.' ||
                expression.charAt(i) == ',') {
                current_str_value = current_str_value + expression.charAt(i);
            } else if (expression.charAt(i) == '+' ||
                       expression.charAt(i) == '-' ||
                       expression.charAt(i) == '*' ||
                       expression.charAt(i) == '/') {
                current_value     = UtilClass.StringToMoney(current_str_value);
                current_str_value = "";

                if (current_operator == 0) {
                    current_operator = expression.charAt(i);
                } else if (GetOperatorPrecedence(current_operator) >= GetOperatorPrecedence(expression.charAt(i))) {
                    if (!val_stack.empty()) {
                        current_value    = EvaluateOperator(current_operator, ((Long)val_stack.pop()).longValue(), current_value);
                        current_operator = expression.charAt(i);

                        while (!op_stack.empty()) {
                            if (((Character)op_stack.peek()).charValue() != '(' &&
                                GetOperatorPrecedence(((Character)op_stack.peek()).charValue()) >= GetOperatorPrecedence(current_operator)) {
                                if (!val_stack.empty()) {
                                    current_value = EvaluateOperator(((Character)op_stack.pop()).charValue(), ((Long)val_stack.pop()).longValue(), current_value);
                                } else {
                                    throw (new Exception("Invalid expression"));
                                }
                            } else {
                                break;
                            }
                        }
                    } else {
                        throw (new Exception("Invalid expression"));
                    }
                } else {
                    op_stack.push(new Character(current_operator));

                    current_operator = expression.charAt(i);
                }

                val_stack.push(new Long(current_value));
            } else if (expression.charAt(i) == '(') {
                if (current_str_value.equals("")) {
                    if (current_operator != 0) {
                        op_stack.push(new Character(current_operator));
                    }
                    op_stack.push(new Character('('));

                    current_operator = 0;
                } else {
                    throw (new Exception("Invalid expression"));
                }
            } else if (expression.charAt(i) == ')') {
                current_value     = UtilClass.StringToMoney(current_str_value);
                current_str_value = "";

                if (current_operator != 0) {
                    if (!val_stack.empty()) {
                        current_value = EvaluateOperator(current_operator, ((Long)val_stack.pop()).longValue(), current_value);

                        while (!op_stack.empty()) {
                            if (((Character)op_stack.peek()).charValue() != '(') {
                                if (!val_stack.empty()) {
                                    current_value = EvaluateOperator(((Character)op_stack.pop()).charValue(), ((Long)val_stack.pop()).longValue(), current_value);
                                } else {
                                    throw (new Exception("Invalid expression"));
                                }
                            } else {
                                break;
                            }
                        }
                    } else {
                        throw (new Exception("Invalid expression"));
                    }
                }

                current_str_value = UtilClass.MoneyToString(current_value);

                if (!op_stack.empty() && ((Character)op_stack.pop()).charValue() == '(') {
                    if (!op_stack.empty() && ((Character)op_stack.peek()).charValue() != '(') {
                        current_operator = ((Character)op_stack.pop()).charValue();
                    } else {
                        current_operator = 0;
                    }
                } else {
                    throw (new Exception("Invalid expression"));
                }
            } else {
                throw (new Exception("Invalid expression"));
            }
        }

        current_value     = UtilClass.StringToMoney(current_str_value);
        current_str_value = "";

        if (current_operator != 0) {
            if (!val_stack.empty()) {
                current_value = EvaluateOperator(current_operator, ((Long)val_stack.pop()).longValue(), current_value);

                while (!op_stack.empty()) {
                    if (((Character)op_stack.peek()).charValue() != '(') {
                        if (!val_stack.empty()) {
                            current_value = EvaluateOperator(((Character)op_stack.pop()).charValue(), ((Long)val_stack.pop()).longValue(), current_value);
                        } else {
                            throw (new Exception("Invalid expression"));
                        }
                    } else {
                        break;
                    }
                }
            } else {
                throw (new Exception("Invalid expression"));
            }
        }

        if (val_stack.empty() && op_stack.empty()) {
            return current_value;
        } else {
            throw (new Exception("Invalid expression"));
        }
    }
}
